# Задача на программирование: декодирование Хаффмана
#
#
# Восстановите строку по её коду и беспрефиксному коду символов.
#
# В первой строке входного файла заданы два целых числа k k k и l l l через пробел — количество различных букв,
# встречающихся в строке, и размер получившейся закодированной строки, соответственно. В следующих k k k строках
# записаны коды букв в формате "letter: code". Ни один код не является префиксом другого. Буквы могут быть
# перечислены в любом порядке. В качестве букв могут встречаться лишь строчные буквы латинского алфавита;
# каждая из этих букв встречается в строке хотя бы один раз. Наконец, в последней строке записана закодированная
# строка. Исходная строка и коды всех букв непусты. Заданный код таков, что закодированная строка имеет минимальный
# возможный размер.
#
# В первой строке выходного файла выведите строку s s s. Она должна состоять из строчных букв латинского алфавита.
# Гарантируется, что длина правильного ответа не превосходит 104 10^4 104 символов.


if __name__ == '__main__':
    d = {}
    len_dict, len_code_word = map(int, input().split())
    for i in range(len_dict):
        child, parent = input().replace(":", " ").split()
        d[child] = parent
    d = {k: v for k, v in sorted(d.items(), key=lambda item: item[1])}
    code_word = input()
    if len_dict == 1:
        print(child)
    else:
        sum = ''
        i = 0
        while len(code_word) >= len_dict:
            for key, val in d.items():
                if code_word[i] == val:
                    sum += key
                    code_word = code_word[len(val):]
                elif code_word[i] + code_word[i+1] == val:
                    sum += key
                    code_word = code_word[len(val):]
                elif code_word[i] + code_word[i+1] + code_word[i+2] == val:
                    sum += key
                    code_word = code_word[len(val):]
            i = 0
        print(sum)







